POJ 1721

好像不需要用到开方什么的。。。

可以知道,一副牌即是一个循环,那么,由于GCD(L,K)=1,所以一次洗牌后,亦是一个循环。其实,K次洗牌等于是T^(2^K)了。既然是循环,必定有周期。那么,周期是多少呢?以例子为例:1->4->6->2->7->3->5。其实对于第一个数(从零始)4,总会有先后移了2^a次方而回到原点,此时就是一个周期了。即是求2^a=1(mod n)。求出最小的a即可知道周期。s%a=t.那么,即是差a-t个状态就可以回到初始的了。

#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

int num[1005];
int tmp[1005];
int ans[1005];

int control(int n){
	int ans=1;
	for(int i=1;i<=n-1;i++){
		ans=(ans*2)%(n);
		if(ans==1)
		return i;
	}
}

int quick(int s,int n){
	int res=1; int p=2;
	while(s){
		if(s&1) res=(res*p)%n;
		s>>=1;
		p=(p*p)%n;
	}
	return res;
}

int main(){
	int n,s,cnt,k,pos;
	while(scanf("%d%d",&n,&s)!=EOF){
		for(int i=1;i<=n;i++)
		scanf("%d",&num[i]);
		int cy=control(n);
	//	cout<<"cy="<<cy<<endl;
		tmp[0]=1;
		cnt=0; k=1;
		while(num[k]!=1){
			tmp[++cnt]=num[k];
			k=num[k];
		}
	/*	for(int i=0;i<n;i++)
		cout<<tmp[i]<<‘ ‘;
		cout<<endl;*/
		s=s%cy;
		s=cy-s;
	//	cout<<"s="<<s<<endl;
		s=quick(s,n);
	//	cout<<"s="<<s<<endl;
		ans[0]=tmp[0];
		pos=0;
		for(int i=1;i<n;i++){
			ans[i]=tmp[pos=(pos+s)%n];
		}
		for(int i=1;i<=n;i++){
			num[ans[i-1]]=ans[i%n];
		}
		for(int i=1;i<=n;i++){
			printf("%d\n",num[i]);
		}
	}
	return 0;
}

  

时间: 2024-10-08 00:47:18

POJ 1721的相关文章

poj 1721 CARDS(置换群)

题目链接:poj 1721 CARDS 题意: 看了半天才看懂,就是一次置换为b[i]=a[a[i]],a[i]=b[i]. 现在已经知道了置换了多少次和当前的序列,问你最原来的序列为 题解: 将这个置换的循环次数ans找出来,再做ans-s次就行了. 1 #include<cstdio> 2 #include<cstring> 3 #include<algorithm> 4 #define F(i,a,b) for(int i=a;i<=b;++i) 5 usi

poj 1721 CARDS(置换)

http://poj.org/problem?id=1721 大致题意:原始序列通过洗牌机洗牌s次后变为当前序列,已知当前序列,求原始序列. 在置换群快速幂运算 研究与探讨中最后有详解,有两种解法,一种是求出置换的长度a(即一副牌洗a次后变回原来的位置),现已知原始序列置换s次变为当前序列,那么当前序列再置换a-s次就是原始序列了.求a就是直接模拟每个置换的过程,直到某序列与当前序列相等.另一种是置换的开方,相当于原始序列的2^s幂是当前序列,将当前序列开2^s次方便是原始序列. 第二种方法暂时

[POJ 1721]CARDS

Description Alice and Bob have a set of N cards labelled with numbers 1 ... N (so that no two cards have the same label) and a shuffle machine. We assume that N is an odd integer. The shuffle machine accepts the set of cards arranged in an arbitrary

ACM训练方案-POJ题目分类

ACM训练方案-POJ题目分类 博客分类: 算法 ACM online Judge 中国: 浙江大学(ZJU):http://acm.zju.edu.cn/ 北京大学(PKU):http://acm.pku.edu.cn/JudgeOnline/ 杭州电子科技大学(HDU):http://acm.hdu.edu.cn/ 中国科技大学(USTC):http://acm.ustc.edu.cn/ 北京航天航空大学(BUAA)http://acm.buaa.edu.cn/oj/index.php 南京

转载:poj题目分类(侵删)

转载:from: POJ:http://blog.csdn.net/qq_28236309/article/details/47818407 按照ac的代码长度分类(主要参考最短代码和自己写的代码) 短代码:0.01K–0.50K:中短代码:0.51K–1.00K:中等代码量:1.01K–2.00K:长代码:2.01K以上. 短:1147.1163.1922.2211.2215.2229.2232.2234.2242.2245.2262.2301.2309.2313.2334.2346.2348

POJ - 3186 Treats for the Cows (区间DP)

题目链接:http://poj.org/problem?id=3186 题意:给定一组序列,取n次,每次可以取序列最前面的数或最后面的数,第n次出来就乘n,然后求和的最大值. 题解:用dp[i][j]表示i~j区间和的最大值,然后根据这个状态可以从删前和删后转移过来,推出状态转移方程: dp[i][j]=max(dp[i+1][j]+value[i]*k,dp[i][j-1]+value[j]*k) 1 #include <iostream> 2 #include <algorithm&

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

POJ——T2271 Guardian of Decency

http://poj.org/problem?id=2771 Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 5932   Accepted: 2463 Description Frank N. Stein is a very conservative high-school teacher. He wants to take some of his students on an excursion, but he is

POJ——T2446 Chessboard

http://poj.org/problem?id=2446 Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 18560   Accepted: 5857 Description Alice and Bob often play games on chessboard. One day, Alice draws a board with size M * N. She wants Bob to use a lot of c